//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
	
	using System.Text;
    using System.Runtime.InteropServices;
    
	public partial class Screen1
    {
		[DllImport("coredll.dll", EntryPoint = "GetSystemPowerState")]
		private static extern uint CEGetSystemPowerState(StringBuilder Buffer, uint Length, out uint Flags);

		[DllImport("coredll.dll", EntryPoint = "SetSystemPowerState")]
		private static extern uint CESetSystemPowerState(char[] sState, uint StateFlags, uint Options);
		
		/*******************************
		Power States and what they mean
		********************************
		“on”,
		POWER_STATE_ON
		Full power mode. All peripherals fully powered and
		enabled. The power manager may still cause the system to
		transition to a low power idle mode during periods of
		reduced and no activity.
		
		“useridle”,
		POWER_STATE_USERIDLE
		Reduced/low power mode. Display backlight is dimmed. 
		
		“systemidle”,
		POWER_STATE_IDLE
		Reduced/low power mode.
		*********************************/

		void Button1_Click(System.Object sender, System.EventArgs e)
		{						
			//Queries the system and finds out what the current power state is.
			//This could be done in a timer.
			StringBuilder systemStateName = new StringBuilder(20);
			uint systemState;
			
			uint nError = CEGetSystemPowerState(systemStateName, (uint) systemStateName.Capacity , out systemState);
			
			Globals.Tags.PowerMode.Value = systemStateName.ToString();
		}
		
		void Button2_Click(System.Object sender, System.EventArgs e)
		{
			//Sets the system state to "systemidle"
			//However, since this is done in a button, it jumps right back into normal run mode.
			//That is why the screen dims and then comes right back up
			
			//What state should we go into?
			string systemStateName = "systemidle";
			
			uint nError = CESetSystemPowerState(systemStateName.ToCharArray(), 0, 0x0);
			
			//We check the state of the system right after we tell it to go idle. 
			//It will jump right back to normal, but at least we know that we went into idle
			//because that is what out get system state says happened.
			StringBuilder currSystemStateName = new StringBuilder(20);
			uint systemState;
			nError = CEGetSystemPowerState(currSystemStateName, (uint) currSystemStateName.Capacity , out systemState);
			Globals.Tags.PowerMode.Value = systemStateName.ToString();
		}
		
		void Button3_Click(System.Object sender, System.EventArgs e)
		{
			//Sets the system state to "reboot"
			//That will soft reboot the unit.
			string systemStateName = "reboot";
			
			uint nError = CESetSystemPowerState(systemStateName.ToCharArray(), 0, 0x0);
		}
		
		
		
    }
}
